#include"keypage.h"

int KeyPageAccess::find(const octet_t *key,size_t keylen)
{
  // Bisectionsverfahren
  int u=0;
  int o=count() - 1;
  int m=u;
  if(count()==0 || keycmp(0,key,keylen)>=0)  return 0; // key <= key(0)
  if(keycmp(o,key,keylen)<0) return count();          // key(max) < key
  while(o-u>1)
  {
    m=(o+u)/2;
    int v = keycmp(m,key,keylen);
    if(v==0) return m;   // key[m]==key
    else if(v<0)         // key(m)< key ?
    {
      u=m;
    }
    else
    {
      o=m;
    }
  }

  return (keycmp(m,key,keylen)<0 ? m+1 : m);
}
